SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #Base
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!Base methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:22'!
isEmpty
	^true! !

!Base methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:50'!
pop: aStack 
self error:'Stack is empty'! !

!Base methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:55'!
top
^self error:'Stack is empty'! !

Object subclass: #Content
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!Content methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:36'!
asign:anElement 
element:= anElement.! !

!Content methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:33'!
element
^element.! !

!Content methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:29'!
isEmpty
^false.! !

!Content methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:42'!
pop: aStack
aStack removeLast.

! !

!Content methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:54'!
top
 ^ element
! !

Object subclass: #OOStack
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:52'!
elements
^elements! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:22'!
initialize 
	elements := OrderedCollection new.
	elements add: Base new.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:22'!
isEmpty
	^(elements atLast: 1) isEmpty.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:46'!
pop
| popedContent  |
popedContent := elements last. 
(elements atLast:1) pop:self.
^popedContent element.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:36'!
push: anElement 
	elements add: (Content new asign:anElement).! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:43'!
removeLast

elements removeLast .! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:49'!
size 
^ (elements  size) - 1.! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'JuanIgnacio 5/8/2013 18:54'!
top
^ (elements last) top.! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
